;;; File: action_bid.lisp -*- Mode: Lisp; Syntax: Common-Lisp; -*-

;;;;******************
;;; Bid Action
;;;;******************

;;; Executarea actiunii bid primita de la agentul agent pentru bunul good
;;; se face altfel:
;;;     1) valoarea ofertelor actuale ale agentului sunt continute in sloturile
;;;        valuation-in, respective, valuation-out
;;;     2) daca numele bunului se afla in lista de input goods a agentului 
;;;        atunci agentul depune un bid de cumparare:
;;;              a)adaug numele si valoarea ofertei in lista deasociatie a 
;;;                produsului cu ofertele de cumparare
;;;     3) daca numele bunului se afla in lista de output goods a agentului 
;;;        atunci agentul depune un bid de vanzare:
;;;              a)adaug numele si valoarea ofertei in lista de asociatie a 
;;;                produsului cu ofertele de vanzare                
;;;		     

(defun bid (agent env &optional good)
  (setq valuation_in (agent-valuation_in agent))
  (setq valuation_out (agent-valuation_out agent))

  ;(format T "~& Executing action ~A for agent ~A with action list ~S for good    
  ;~S " `(ACTION=bid=, valuation_in) (agent-name agent) (agent-action agent)  
  ;(good-name good))

  (cond ((member (good-name good) (agent-input_goods agent))
    		  (setf (good-buy_bids good) (cons 
			(cons (agent-name agent) valuation_in) (good-buy_bids good)))

              (format t "~% Ofertele de cumparare pentru bunul ~A :~&~S " 
                              (good-name good) (good-buy_bids good)))

	 ((member (good-name good) (agent-output_goods agent))
          	  (setf (good-sell_bids good) (cons 
		     (cons (agent-name agent) valuation_out) (good-sell_bids good)))
		  (format t "~% Ofertele de vanzare pentru bunul ~A : ~S" 
					(good-name good) (good-sell_bids good)))
       (T nil)
  )              			
)



