;;; File: action_breach.lisp -*- Mode: Lisp; Syntax: Common-Lisp; -*-

;;;;******************
;;; Breach Action
;;;;******************

;;; Executarea actiunii breach primita de la agentul agent pentru bunul good
;;; so contractul semnat la t_issue, se face altfel:
;;;     1) ideintificarea contractului care se rupe 
;;;    	a) in lista agent_active_contracts memorez contractele active ale 
;;;            agentului pentru bunul g (cu functia (get_contracts agent good))
;;;            (un agent poate avea mai multe contracte pentru un singur produs, 
;;;            dar semnate la runde diferite.
;;;         b) din lista acesta extrag singurul contract care s-a semnat la 
;;;            t_issue (cu functia (get_contract agent_active_contracts t_issue)
;;;         c) variabila breached_contract va contine acest contract
;;;     2) identific numele victimei, ca fiind partenerul sau
;;;     3) obtin agentul cu numele respective (cu return_agent nume lista)
;;;     4) calculez penalitatea 
;;;        (cu (compute_penalty victim breached_contract good env)
;;;     5) actualizez scorurile celor doi agenti
;;;     6) sterg contractul din lista de contracte ale bunului
;;;     7) sterg contractul din lista de contracte active ale agentului si ale 
;;;        victimei 

(defun breach (agent env &optional good t_issue)
 "La un tact un agent poate depune un singur bid pentru un anumit good
  Daca semneaza un contract acesta va fi unic identificat prin numele 
  Unui agent semnatar si runda in care s-a semnat t_issue"
  
  (format T "~& Executing action ~A for agent ~A with action list "  "ACTION=Breach" (agent-name agent) ;(agent-action agent)
)
(setq breached_contract 
      (get_agent_contract_for_good_at_tissue agent good t_issue))
 
   
 (cond ((equal breached_contract nil) 
            (format t "Nu exista un astfel de contract in mediu"))

       (T (format t "~%Contractul care se rupe este: ~S" breached_contract)
            
           (cond ((equal (agent-name agent) (first (car breached_contract)))
		      	(setq victim (second (car breached_contract))))
                   (T  (setq victim (first (car breached_contract)))))
           (format t "~%Victima este agentul ~S" victim)

           (setf victim_agent (return_agent victim (environment-agents env)))
           (breach_contract agent victim_agent breached_contract good env) 
       );T
   );cond

)
)



(defun get_contracts (agent good)
"Intoarce lista contractelor agentului agent pentru bunul g"
    (setq my_contracts nil)
    (dolist  (contract (good-contract good))
        (cond ((equal (agent-name agent) (car (first contract))) 
			;daca agentul este vanzator
	            (setf my_contracts (list contract my_contracts)))
                 ((equal (agent-name agent) (car (second contract))) 
			;daca agentul este cumparator
	            (setf my_contracts (list contract my_contracts)))
     ))
  my_contracts ;pentru ca functia intoarce ultima forma evaluata
)

;;; "din lista de contracte active a unui agent pentru bunul g se extrage 
;;;; singurul contract care s-a semnat la t_issue"

(defun get_contract (contracts t_issue)
   (setq breached_contract nil)
   (dolist (item contracts)
      (cond ((equal t_issue (nth 4 item)) (setf breached_contract item))))
   breached_contract ;ce intoarce functia
)



