;;; File: contract.lisp -*- Mode: Lisp; Syntax: Common-Lisp; -*-

;;;;****************************
;;; Get contracts
;;;;****************************

;;;Intoarce lista contractelor agentului agent pentru bunul g

(defun get_agent_contracts_for_good (agent good)
    (setq my_contracts_for_good nil)
    (dolist  (contract (good-contract good))
        (cond (( or (equal (agent-name agent) (car (first contract))) ;vanzator
                   (equal (agent-name agent) (car (second contract)));cumparator
                )
                (cond ((equal my_contracts_for_good nil) 
	                    (setf my_contracts_for_good (list contract)))
	                (T (setf my_contracts_for_good (cons contract 
   my_contracts_for_good)))
                )
              )
         )
     )
  my_contracts_for_good 
)

;;; Intoarce lista contractelor agentului semnate la tissue
(defun get_agent_contracts_at_tissue (agent t_issue env)
   (setq my_contracts_at_tissue nil)
   (for-each good in (environment-goods env) do
       (dolist  (contract (good-contract good))
        (cond (( and
                 (or (equal (agent-name agent) (car (first contract))) ;vanzator
                   (equal (agent-name agent) (car (second contract)));cumparator
                 )
                 (equal t_issue (get_contract_tissue contract))
               )
                (cond ((equal my_contracts_at_tissue nil) 
	                    (setf my_contracts_at_tissue (list contract)))
	                (T (setf my_contracts_at_tissue (cons contract 
   my_contracts_at_tissue)))
                )
              )
         )
       )
   )

  my_contracts_at_tissue 
)

;;; Intoarce lista contractelor agentului pentru bunul good semnate la tissue
;;;      a) selectez contractele pentru bunul good
;;;      b) din acest rezultat selectez contractul semnat la t_issue

(defun get_agent_contract_for_good_at_tissue (agent good t_issue)
      (setq contract nil)
      (setq contracts (get_agent_contracts_for_good agent good))
      (dolist (item contracts)
          (cond ((equal t_issue (get_contract_tissue item)) 
                   (setf contract item))))
      contract    
)

(defun breach_contract (breacher victim contract good env)
	 
      (setq penalty (compute_penalty victim contract good env))
      (format t "~%Penalizarea este: ~A" penalty)

      (setf (agent-score victim) (+ (agent-score victim) penalty))
      (setf (agent-score breacher) (- (agent-score breacher) penalty))

      (format t "~%Scorul pentru agentul ~S dupa penalizare este: ~S" 
               (agent-name victim) (agent-score victim))
	(format t "~%Scorul pentru agentul ~S dupa penalizare este: ~S" 
		(agent-name breacher) (agent-score breacher))

     (setf (good-contract good) (remove contract (good-contract good)))

     (remove_contract_from_agent breacher contract)
     (remove_contract_from_agent victim contract)
)

;;;intoarce pretul contractului pentru bunul output al agentului
(defun get_Rp (agent)
 (setq Rp 0) 
 (dolist (contract (agent-active_contracts agent))
       (cond ((equal (car (agent-output_goods agent))
                     (get_contract_good_name contract))
                  (setf Rp (get_contract_price contract)))
             (T (format t "~%The victim is a consumer, hence it is presumable")
                (setq Rp (agent-valuation_out agent)))
        )
   )         
  Rp
)

;;;intoarce pretul contractelor pentru bunurile de intrare
;;; !!!! nu functioneaza bine daca agentul a achizitionat de mai multe ori 
;;;  acelasi bun de intrare
(defun get_Ip (agent)
 (setq Ip 0) 
 (dolist (contract (agent-active_contracts agent))
       (cond ((not (equal (car (agent-output_goods agent))				   				  (get_contract_good_name contract)))
                (setf Ip (+ Ip (get_contract_price contract))))
             (T nil)
        )
   )         
 Ip
)

;;; intoarce pretul contractelor pentu bunurile de intrare cu exceptia 
;;; pretului pentru contractul incalcat
(defun get_Ip^g (agent breached_contract_price)
 (setq Ip^g (- (get_Ip agent) breached_contract_price)) 
 )

;;; intoarce suma ofertelor depuse de agent pentru bunurile de intrare
;;; pentru care a castigat contracte cu exceptia ofertei depuse pentru bunul 
;;; curent
;;; !!!! nu functioneaza bine daca agentul a achizitionat de mai multe ori 
;;;  acelasi bun de intrare
(defun get_Vp_g (agent contract)
(setq Vp_g 0) 
(cond ((is_seller (agent-name agent) contract)				   	
		    (setf Vp_g (- (get_Vp agent contract) 
                              (get_contract_seller_bid contract))))
      (T  (setf Vp_g (- (get_Vp agent contract)
                         (get_contract_buyer_bid contract))))
 )       
 Vp_g
)

;;; intoarce suma ofertelor depuse de agent pentru bunurile de intrare
;;; pentru care a castigat contracte 
;;; !!!! nu functioneaza bine daca agentul a achizitionat de mai multe ori 
;;;  acelasi bun de intrare
(defun get_Vp (agent contract)
 (setq Vp 0) 
 (dolist (item (agent-active_contracts agent))
       (cond ((is_seller (agent-name agent) contract)				   				 (setf Vp (+ Vp (get_contract_seller_bid item))))
             (T  (setf Vp (+ Vp (get_contract_buyer_bid item))))
        )
   )         
 Vp
)


;intoarce numelele agentului parner cu agentul agent_name in contractul contract
(defun get_partner_name (agent_name contract)
   (cond ((is_seller agent_name) (setf name (get_buyer_name contract)))
         (T (setf name (get_seller_name contract)))
   )
name
)


(defun get_contract_seller_name (contract)
   (car (nth 0 contract)))

(defun get_contract_buyer_name (contract)
   (car (nth 1 contract)))

(defun get_contract_seller_bid (contract)
   (cdr (nth 0 contract)))

(defun get_contract_buyer_bid (contract)
   (cdr (nth 1 contract)))

(defun get_contract_good_name (contract)
   (nth 2 contract))

(defun get_contract_price (contract)
   (nth 3 contract))

(defun get_contract_tissue (contract)
   (nth 4 contract))

(defun get_contract_tmaturity (contract)
   (nth 5 contract))

(defun get_contract_seller_Po (contract)
   (nth 6 contract))

(defun get_contract_buyer_Po (contract)
   (nth 7 contract))

;;; adauga un contract in lista de contracte active ale agentului
;;; se testeaza initial daca aceasta lista este vida, pentru a nu aparea un nil 
;;; la apelul functiei list

 (defun add_contract_to_agent (agent contract)
   (setf (agent-active_contracts agent) 
          (cond ((equal (agent-active_contracts agent) nil)
                     (list contract))
                (T  (append  (agent-active_contracts agent) (list contract)))))
 )

(defun remove_contract_from_agent (agent contract)
   (setf (agent-active_contracts agent) 
          (remove contract (agent-active_contracts agent)))
 )

