;;# mkForm w
;;
;; 
;; Add an agent to tha agents_list
;;
;; Arguments:
;;    w -	Name to use for new top-level window.

(in-package "TK")
(defvar *tablist*)

(defun mkForm (&optional (w '.form)) 
    (setq *tablist* nil)
    (if (winfo :exists w :return 'boolean) (destroy w))
    (toplevel w)
    (dpos w)
    (wm :title w "Agent Inregistration")
    (wm :iconname w "Form")
    (message (conc w '.msg) :font :Adobe-times-medium-r-normal--*-180* :width "4i" 
	    :text "Click the \"OK\" button or type return when you're done.")
   (dolist (i '(f1 f2 f3 f4 f5 f6 f7 f8 f9))
	(frame (conc w '|.| i) :bd "1m")
	(entry (conc w '|.| i '.entry) :relief "sunken" :width 40)
	(bind (conc w '|.| i '.entry) "<Tab>" '(Tab *tabList*))
	(bind (conc w '|.| i '.entry) "<Return>" `(destroy ',w))
	(label (conc w '|.| i '.label))
	(pack (conc w '|.| i '.entry) :side "right")
	(pack (conc w '|.| i '.label) :side "left")
	(push (conc i '.entry) *tablist*))
    (setq *tablist* (nreverse *tablist*))  
    (funcall (conc w '.f1.label) :config :text "Type: ")
    (funcall (conc w '.f2.label) :config :text "Names: ")
    (funcall (conc w '.f3.label) :config :text "Stored items: ")
    (funcall (conc w '.f4.label) :config :text "Active contracts: ")
    (funcall (conc w '.f5.label) :config :text "Input goods: ")
    (funcall (conc w '.f6.label) :config :text "Output goods: ")
    (funcall (conc w '.f7.label) :config :text "Valuation IN: ")
    (funcall (conc w '.f8.label) :config :text "Valuation OUT: ")
    (funcall (conc w '.f9.label) :config :text "Money: ")
    
    
    
    (button (conc w '.add) :text "Add" 
         :command '(user::add_agent 'reactive_agent 's4 '() '() '() '(g11) 20 20 100))
    (button (conc w '.ok) :text "OK" :command (tk-conc "destroy " w))
    
    (pack (conc w '.msg) (conc w '.f1) (conc w '.f2) (conc w '.f3)
	  (conc w '.f4) (conc w '.f5) 
	  (conc w '.f6) (conc w '.f7) 
	  (conc w '.f8) (conc w '.f9) 
	  
	  (conc w '.add) :side "top" :fill "x")
          ;(conc w '.ok) :side "left" :fill "x")

)

;; The procedure below is invoked in response to tabs in the entry
;; windows.  It moves the focus to the next window in the tab list.
;; Arguments:
;;
;; list -	Ordered list of windows to receive focus

(defun Tab (list) 
  (setq i (position (focus :return t) list))
  (cond ((null i) (setq i 0))
	(t (incf i)
	   (if (>=  i (length list) )
	       (setq i 0))))
  (focus (nth i list ))
)

