(in-package "TK")
;;# mkPlot w
;;
;; Create a top-level window containing a canvas displaying a simple
;; graph with data points that can be moved interactively.
;;
;; Arguments:
;;    w -	Name to use for new top-level window.

(defun mkPlot ( &optional (w '.plot ) &aux c font x y item)
    (debugging t)
    (if (winfo :exists w :return 'boolean) (destroy w))
    
    (toplevel w )
    (dpos w)
    (wm :title w  "Task Dependency Network " : w)
    (wm :iconname w "Plot")
    (setq c (conc w '.c))

    (message (conc w '.msg) :font :Adobe-Times-Medium-R-Normal-*-180-* :width 400 
	    :bd 2 :relief "raised" :text "You can adjust the network by dragging any of the agents and goods with mouse button 1.")
    (canvas c :relief "raised" :width 650 :height 500)
    (button (conc w '.ok) :text "OK" :command  "destroy " : w)
    (pack (conc w '.msg) (conc w '.c) :side "top" :fill "x")
    (pack (conc w '.ok) :side "bottom" :pady 5)

    (setq font :Adobe-helvetica-medium-r-*-180-*)

    ;(funcall c :create "line" 100 250 400 250 :width 2)
    ;(funcall c :create "line" 100 250 100 50 :width 2)
    ;(funcall c :create "text" 225 20 :text "A Simple Plot" :font font :fill "brown")
    
    
 (draw_agents user::*current_env* c) 
 (draw_goods user::*current_env* c)

    ;(funcall c :bind "point" "<Any-Enter>"  c : " itemconfig current -fill red")
    ;(funcall c :bind "point" "<Any-Leave>"   c : " itemconfig current -fill SkyBlue2")
    (funcall c :bind "point" "<1>"  `(plotdown ',c |%x| |%y|))
    (funcall c :bind "point" "<ButtonRelease-1>"  c : " dtag selected")
   (funcall c :bind "point" "<ButtonRelease-3>" '(format t "~% ~S" point))
    (funcall c :bind "agent_name" "<ButtonRelease-3>" '(format t "~% aaa" ))
    (bind c "<B1-Motion>" `(plotmove ',c |%x| |%y|))
)

(defvar plotlastX 0)
(defvar plotlastY 0)

(defun plotDown (w x y) 
    (funcall w :dtag "selected")
    (funcall w :addtag "selected" "withtag" "current")
    (funcall w :raise "current")
    (setq plotlastY y)
    (setq plotlastX x)
)

(defun plotMove (w x y &aux )
  (let ((oldx  plotlastX)
	(oldy  plotlastY))
    ;; Note plotmove may be called recursively... since
    ;; the funcall may call something which calls this.
    ;; so we must set the global plotlastx before the funcall..
    (setq plotlastx x)
    (setq plotlastY y) 
    (funcall w :move "selected" (- x oldx) (- y oldy))
    )
  )


(defun draw_goods (env c)
    (setq x 50)
    (setq y 50)
 (sloop for good in (user::environment-goods env) do
       (setf x (+ x 20))
       (setf y (+ y 20))
        (draw_good good c x y "Skyblue2")     
 )
) 

(defun draw_good (good c x y color)
     (setq point (list x y)) 
     (setq item (funcall c :create "oval" (- x 15) (- y 15) 
			   (+ x 15) (+ y 15) :width 1 :outline "black" 
			   :fill color 
			   :return 'string ))
      (setq itemtext (funcall c :create "text" x y :text (user::good-name good) :return 'string))
      ;(winfo :text itemtext :return 'string)    
       
       (funcall c :addtag "point" "withtag" item)
       (funcall c :addtag "point" "withtag" itemtext)
        (format t "~%Item text ~S" itemtext)
        (format t "~%Item ~S" item)

)

(defun draw_agents (env c)
   (setq x 20)
   (setq y 20)
 (sloop for agent in (user::environment-agents env) do
      ;(setf x )
      ;(setf y )
      (cond ((user::is_supplier agent)  (draw_agent agent c 20 (random 500) "Green"))
    					
             ((user::is_consumer agent) 				 
                                       (draw_agent agent c 550 (random 500) "gray"))                                                
	     (T 	
                     (draw_agent agent c (random 500) (random 500) "Yellow")))
 )
)


(defun draw_agent (agent c x y color)

       (setq item (funcall c :create "rectangle" (- x 15) (- y 15) 
			   (+ x 15) (+ y 15) :width 1 :outline "black" 
			   :fill color 
			   :return 'string ))
       (setq itemtext (funcall c :create "text" x y :text (user::agent-name agent) :return 'string))
       (setq point (list x y))
       (funcall c :addtag "point" "withtag" item)
       (funcall c :addtag "point" "withtag" itemtext)
)