;;; File: penalty.lisp -*- Mode: Lisp; Syntax: Common-Lisp; -*-




;
(setq *env-penalty* 5) ;mediul stabileste o suma fixa pentru penalitate

;(setq *procent* 0.5)   ; procentul din valoarea contractului in cazul 
			      ;;;penalizarii procentuale


;;;;functie folosita in program
;;; intoarce valoarea penalizarii calculate
;;; pentru contractul curent

;; apeleaza una din functiile de calcul a penalitatii

(defun compute_penalty (victim contract good env)


 (cond ((equal "De" tk::*penalty*) (expectation_damages victim contract good env))
        ((equal "Do" tk::*penalty*) (opportunity_cost victim contract good env))
        ((equal "Dr" tk::*penalty*) (reliance_damages victim contract good env))
        ((equal "Dp_f" tk::*penalty*) (fixed_penalty victim contract good env))
        ((equal "Dp_p" tk::*penalty*) (procent_penalty victim contract good env))
        (T (format t "Please, set the penalty type for the current experiment"))
 )        

  ;(fixed_penalty victim contract good env)
  ;(procent_penalty victim contract good env)
  ;(expectation_damages victim contract good env)
  ;(reliance_damages victim contract good env)
;(opportunity_cost victim contract good env)


 )


(defun fixed_penalty (victim contract good env)

  ;*env-penalty*
  tk::*fixed_Penalty*
)

(defun procent_penalty (victim contract good env)
     ;(* *procent* (get_contract_price contract))
     (* (/ tk::*procent* 100) (get_contract_price contract))
     
)


;;;;********************************
;;; Expectation damages
;;;;********************************
;;; intoarce penalitatea in cazul politicii expectation damages
;;; a) victima este cumparator (supplier breaches)
;;;      daca victima este presumable si are output contract => P=max(Rp-Ip,0)
;;;      in caz contrar P=vp-Pc unde vp este valuatia agentului la momentul 
;;;       semnarii contractului
;;;       in cazul de fata am luat direct valuatia la momentul t_breach, 
;;;       considerand ca ea nu se schimba in timp
;;;       daca agentul isi schimba valuatia in timp ar trebui modificat codul 
;;;       aici
;;; b) victima este vanzator (consumer breaches)
;;;      if victim presumable=> P= max(Pc-Ip^g,0)
;;;      otherwise P=Pc-vp
;;;      la fel am considerat ca vp nu se schimba in timp
(defun expectation_damages (victim contract good env)
   (setq penalty 0)
   (format t "~%The victim is: ~S" victim)
   (format t "~% The victim is presumable?......~S" (is_presumable victim))
   (format t "~% The victim has output contract ?......~S" (has_output_good_contract victim))
   (cond ((is_seller victim contract)  
          (format t "The victim is seller") 
          (cond ((and (is_presumable victim) (has_output_good_contract victim))
                 (setf penalty (max (- (get_Rp victim) (get_Ip victim)) 0)))
                (T (setf penalty 
                 (- (agent-valuation_in victim) (get_contract_price contract))))
          )
         )
        (T (format t "The victim is buyer")
           (cond ((is_presumable victim)
                 (setf penalty 
                   (max 0 (- (get_contract_price contract) 
                            (get_Ip^g victim (get_contract_price contract))) 
                 )))
                (T (setf penalty 
                 (- (get_contract_price contract) (agent-valuation_in victim))))
          )
) 
   )
penalty
)

;;;;********************************
;;; Reliance damages
;;;;********************************
;;; intoarce penalitatea in cazul politicii reliance damages
;;; a) victima este cumparator (supplier breaches)
;;;      daca victima este presumable si are output contract => P=max(Rp-Ip,0)
;;;      in caz contrar P=vp-Pc unde vp este valuatia agentului la momentul 
;;;       semnarii contractului
;;;       in cazul de fata am luat direct valuatia la momentul t_breach, 
;;;       considerand ca ea nu se schimba in timp
;;;       daca agentul isi schimba valuatia in timp are trebui modificat codul 
;;;       aici
;;; b) victima este vanzator (consumer breaches)
;;;      if victim presumable=> P= max(Pc-Ip^g,0)
;;;      otherwise P=Pc-vp
;;;      la fel am considerat ca vp nu se schimba in timp
 (defun reliance_damages (victim contract good env)
   (setq penalty 0)
   (format t "~%The victim is: ~S" victim)
   (format t "~% The victim is presumable?......~S" (is_presumable victim))
   (format t "~% The victim has output contract ?......~S" (has_output_good_contract victim))
   (cond ((is_seller victim contract)  
          (format t "The victim is seller") 
          (cond ((and (is_presumable victim) (has_output_good_contract victim))
                (setf penalty (+ (- (get_Vp_g victim contract)
                                     (get_Ip^g victim 
                                              (get_contract_price contract)))
                                (- (get_Rp victim) (agent-valuation_out victim)) 
                               )))   
                (T (setf penalty 
                      (- (get_Vp_g victim) (get_Ip^g victim ))))
           )
         )
        (T (format t "The victim is buyer")
           (setf penalty (- (get_Rp victim) 
                            (get_Ip victim ))))
                 
    )
penalty
)

;;;;********************************
;;; Opportunity cost
;;;;********************************
;;; intoarce penalitatea in cazul politicii opportunity cost
;;; a) victima este cumparator (supplier breaches)
;;;      daca victima este presumable si are output contract => P=max(Rp-Ip,0)
;;;      in caz contrar P=vp-Pc unde vp este valuatia agentului la momentul 
;;;       semnarii contractului
;;;       in cazul de fata am luat direct valuatia la momentul t_breach, 
;;;       considerand ca ea nu se schimba in timp
;;;       daca agentul isi schimba valuatia in timp are trebui modificat codul 
;;;       aici
;;; b) victima este vanzatorul (consumer breaches)
;;;      if victim presumable=> P= max(Pc-Ip^g,0)
;;;      otherwise P=Pc-vp
;;;      la fel am considerat ca vp nu se schimba in timp
(defun opportunity_cost (victim contract good env)
   (setq penalty 0)
   (format t "~%The victim is: ~S" victim)
   (format t "~% The victim is presumable?......~S" (is_presumable victim))
   (format t "~% The victim has output contract ?......~S" 
                       (has_output_good_contract victim))
    (cond ((is_seller victim contract)  
             (format t "~%The victim is seller") 
              (setf penalty (get_contract_seller_Po contract)))
        (T (format t "~%The victim is buyer")
              (setf penalty (get_contract_buyer_Po contract)))

     ) 
 penalty
0
)




;;;intoarce true daca agentul este vanzator in cotractul curent 
(defun is_seller (agent contract)
   (cond ((equal (agent-name agent) (get_contract_seller_name contract))
            (setq seller T))
         (T (setf seller nil))
   )
seller
)

;;;intoarce true daca agentul a semnat contract pentru bunul produs de el
;;; in scenariul current fiecare agent produce un singur bun
;;;=> lista output_goods va contine un singur element
(defun has_output_good_contract (agent)
   (setf has_output_good T)
   (cond ((is_consumer agent) (setf has_output_good T))
        (T (dolist (output_good_name (agent-output_goods agent))
               (cond ((not(member output_good_name (contracted_goods agent)))
                          (setf has_output_good nil))
                     (T nil)) 
            )
        )  
   )
has_output_good
)

;;;intoarce true daca victima are contracte pentru toate bunurile de intrare
(defun is_presumable (agent)
   (setf presumable T)
  (cond ((is_supplier agent) (setf presumable T))
        (T (dolist (input_good_name (agent-input_goods agent))
               (cond ((not(member input_good_name (contracted_goods agent)))
                          (setf presumable nil))
                     (T nil)
                ) 
           )
        )  
  )
presumable
) 

;;;intoarce true daca agentul este supplier
;;;un agent este supplier daca lista de bunuri consumate este nula
(defun is_supplier (agent)
 (cond ((equal (agent-input_goods agent) nil) T)
       (T nil))
)

;;;intoarce true daca agentul este consumer
;;;un agent este consumer daca lista de bunuri produse este nula
(defun is_consumer (agent)
 (cond ((equal (agent-output_goods agent) nil) T)
       (T nil))
)


;;; se intoarce lista cu numele de bunuri contractate
;;; (care apar in contractile active ale agentului)
(defun contracted_goods (agent)
  (setq my_contracted_goods nil)
     (dolist (contract (agent-active_contracts agent))
            (setf my_contracted_goods 
              (cons (get_contract_good_name contract) my_contracted_goods))
     )
  my_contracted_goods
)   
  
