;;; File: percepts.lisp -*- Mode: Lisp; Syntax: Common-Lisp; -*-
;;; Contine functiile
;;; 	market-percept-fn (agent env)
;;;   find_interested_agents (env)
;;;
;********************
;Percepts
;********************

;;; deoacamdata fiecare agent percepe acelasi lucru, si anume lista tuturor
;;; bunurilor din environment
;;; pentru optimizare ar trebui sa se aplice o masca, in urma careia agentul sa 
;;; perceapa doar ce e cu adevarat interesat

(defun market-percept-fn (agent env)
"Percept is a the list containing all goods in the market.
 The agents will use only information what they need"
 (list (environment-goods env))
)

(defun find_interested_agents (env)
"Intoarce lista cu agentii care au depus pentru un anumit produs"  
      (setf interested_agents nil)
	(for-each good in (environment-goods env) do
	   (for-each interested_agent in 
		(or (good-buy_agents good) (good-sell_agents good)) do
		(setf interested_agents (cons interested_agent interested_agents))))
)


