;;; File: reactive_agent.lisp -*- Mode: Lisp; Syntax: Common-Lisp; -*-



;apeleaza functia general agent care creaza un agent
;si specifica programul dupa care acesta ia decizii

(defun reactive_agent (name 
                       stored_items 
                       active_contracts 
                       input_goods 
                       output_goods 
                       valuation_in 
                       valuation_out 
                       money)
      (setq type 'R)
	(general_agent name  (program name) stored_items active_contracts 		  input_goods output_goods valuation_in valuation_out money type)
)


;;;; programul dupa care agentul ia decizii
;;;; percept este lista primita de la mediu
;;;; fiind lista intoarsa de functia market-percept-fn (agent env)
;;;; intoarce o lista de actiuni, ex: (bid good) sau (breach good t_issue)
;;;; functiile booleene (bid_OK agent_name good) si (breach_OK agent_name good)
;;;; testeaza daca executa o actiune sau alta 
 
(defun program (name)
  #'(lambda (percept)
       ;(destructuring-bind (bid breach not_interested) percept)
       (setf actions_list nil);lista de actiuni intoarsa de functia program            
	 ;(format T "~% Percept for agent ~A are:~% ~S" name percept)
       ;(setf current_good (car (car percept)))    
       (setq t_issue 1);!!!se va modifica contractul care vreau sa-l rup       
  (for-each good in (car percept) do
          (cond ((bid_OK name good percept)
				(setf actions_list (cons `(bid ,good) 							actions_list)))
   		    ((breach_OK name good percept)
                        ; breach_OK seteaza si t_issue care identifica ce 
                        ; contract se va rupe
                        ; daca agentul detine mai multe contracte
                        ; pentru bunul current g
                    (setf actions_list (cons `(breach ,good ,tissue_of_contract) 				 	actions_list)))
           )
    )
   (list actions_list) ; environment executa actiunile intoarse de functia                			     ;program
   )
  )


;;; daca agentul nu se regaseste in lista contractelor active ale bunului
;;; executa actiunea bid (cumpara, vinde, nil  daca numele produsului nu se afla   
;;; lista de input a agentului

(defun bid_OK (agent_name good percept)
  (setq agents_with_contract (has_contract good))
  (format t "~%Agentii care detin contracte pentu bunul ~S: ~S" 
			(good-name good)agents_with_contract)
  (not (member agent_name agents_with_contract));daca nu e membru intoarce TRUE
)

(defun has_contract (good)
"Intoarce lista de agenti care au contracte din rundele trecute pentru bunul good"
 (setq agents nil)
 (dolist  (contract (good-contract good))
   (setf agents (cons (car (first contract)) agents))
   (setf agents (cons (car (second contract)) agents))
)
agents ;pentru ca functia intoarce ultima forma evaluata
)

;;; intoarce true daca agentul va rupe contractul care il detine pentru bunul 
;;; good

(defun breach_OK (agent_name good percept)
  (setf tissue_of_contract 1) ;ce contract se va rupe pentru bunul g
  (if (equal agent_name 'c3)   T)
)


