(in-package "TK")
;;# mkRadio w
;;
;; Create a top-level window that displays a bunch of radio buttons.
;;
;; Arguments:
;;    w -	Name to use for new top-level window.

(defun mkRadio (&optional (w '.r1)) 
    (if (winfo :exists w :return 'boolean) (destroy w))
    (toplevel w)
    (dpos w)
    (wm :title w "Set Penalty")
    (wm :iconname w "Radiobuttons")
    (message (conc w '.msg) :font :Adobe-times-medium-r-normal--*-180* :aspect 300 
	    :text "Click the \"OK\" button when you've set the penalty.")
    (frame (conc w '.frame) :borderwidth 10)
    (frame (conc w '.frame2))
    (pack (conc w '.msg) :side "top")
    (pack (conc w '.msg) :side "top")
    (pack (conc w '.frame) :side "top" :fill "x" :pady 10)
    (pack (conc w '.frame2) :side "bottom" :fill "x")

    (frame (conc w '.frame.left))
    (frame (conc w '.frame.right))
    (pack (conc w '.frame.left) (conc w '.frame.right) :side "left" :expand "yes")

    (radiobutton (conc w '.frame.left.b1) :text "Expectation Damages" :variable '*penalty* 
	    :relief "flat" :value "De")
    (radiobutton (conc w '.frame.left.b2) :text "Opportunity Cost" :variable '*penalty* 
	    :relief "flat" :value "Do")
    (radiobutton (conc w '.frame.left.b3) :text "Reliance Damages" :variable '*penalty* 
	    :relief "flat" :value "Dr")
    (radiobutton (conc w '.frame.left.b4) :text "Party Design (fixed penalty) " :variable '*penalty* 
	    :relief "flat" :value "Dp_f")
    (radiobutton (conc w '.frame.left.b5) :text "Party Design (procent penalty)" :variable '*penalty* 
	    :relief "flat" :value "Dp_p")

    (pack (conc w '.frame.left.b1) (conc w '.frame.left.b2) (conc w '.frame.left.b3) (conc w '.frame.left.b4) 
	   (conc w '.frame.left.b5)   :side "top" :pady 2 :anchor "w")

    ;(radiobutton (conc w '.frame.right.b1) :text "Red" :variable 'color 
;	    :relief "flat" :value "red")
;    (radiobutton (conc w '.frame.right.b2) :text "Green" :variable 'color 
;	    :relief "flat" :value "green")
;    (radiobutton (conc w '.frame.right.b3) :text "Blue" :variable 'color 
;	    :relief "flat" :value "blue")
;    (radiobutton (conc w '.frame.right.b4) :text "Yellow" :variable 'color 
;	    :relief "flat" :value "yellow")
;    (radiobutton (conc w '.frame.right.b5) :text "Orange" :variable 'color 
;	    :relief "flat" :value "orange")
;    (radiobutton (conc w '.frame.right.b6) :text "Purple" :variable 'color 
;	    :relief "flat" :value "purple")
;    (pack (conc w '.frame.right.b1) (conc w '.frame.right.b2) (conc w '.frame.right.b3) 
;	    (conc w '.frame.right.b4) (conc w '.frame.right.b5) (conc w '.frame.right.b6) 
;	    :side "top" :pady 2 :anchor "w")
    
    (button (conc w '.frame2.ok) :text "OK" :command (tk-conc "destroy " w) :width 12)
    (button (conc w '.frame2.vars) :text "See Variables" :width 12
	    :command `(showvars (conc ',w '.dialog) '(*penalty* *fixed_penalty*)))
   (button (conc w '.frame2.fixedPenalty) :text "Set values" :width 12
	    :command `(mkVScale (conc ',w '.dialog)))

    (pack (conc w '.frame2.ok) (conc w '.frame2.vars) (conc w '.frame2.fixedPenalty) :side "left" :expand "yes" :fill "x")
)


